国产xxxx99真实实拍_久久不雅视频_高清韩国a级特黄毛片_嗯老师别我我受不了了小说

資訊專欄INFORMATION COLUMN

leetcode436. Find Right Interval

robin / 1841人閱讀

摘要:題目要求假設(shè)一個二維的整數(shù)數(shù)組中每一行表示一個區(qū)間,每一行的第一個值表示區(qū)間的左邊界,第二個值表示區(qū)間的右邊界。

題目要求
Given a set of intervals, for each of the interval i, check if there exists an interval j whose start point is bigger than or equal to the end point of the interval i, which can be called that j is on the "right" of i.

For any interval i, you need to store the minimum interval j"s index, which means that the interval j has the minimum start point to build the "right" relationship for interval i. If the interval j doesn"t exist, store -1 for the interval i. Finally, you need output the stored value of each interval as an array.

Note:

You may assume the interval"s end point is always bigger than its start point.
You may assume none of these intervals have the same start point.
 

Example 1:

Input: [ [1,2] ]

Output: [-1]

Explanation: There is only one interval in the collection, so it outputs -1.
 

Example 2:

Input: [ [3,4], [2,3], [1,2] ]

Output: [-1, 0, 1]

Explanation: There is no satisfied "right" interval for [3,4].
For [2,3], the interval [3,4] has minimum-"right" start point;
For [1,2], the interval [2,3] has minimum-"right" start point.
 

Example 3:

Input: [ [1,4], [2,3], [3,4] ]

Output: [-1, 2, -1]

Explanation: There is no satisfied "right" interval for [1,4] and [3,4].
For [2,3], the interval [3,4] has minimum-"right" start point.
NOTE: input types have been changed on April 15, 2019. Please reset to default code definition to get new method signature.

假設(shè)一個二維的整數(shù)數(shù)組中每一行表示一個區(qū)間,每一行的第一個值表示區(qū)間的左邊界,第二個值表示區(qū)間的右邊界?,F(xiàn)在要求返回一個整數(shù)數(shù)組,用來記錄每一個邊界右側(cè)最鄰近的區(qū)間。

[ [1,4], [2,3], [3,4] ]表示三個區(qū)間,[1,4]不存在最鄰近右區(qū)間,因此[1,4]的最鄰近右區(qū)間的位置為-1。[2,3]最鄰近右區(qū)間為[3,4],因此返回2,[3,4]也不存在最臨近右區(qū)間,因此也返回-1。最終函數(shù)返回數(shù)組[-1,2,-1]。

思路1:二分法

如果我們將區(qū)間按照左邊界進行排序,則針對每一個區(qū)間的右邊界,只要找到左邊界比這個值大的最小左邊界所在的區(qū)間即可。這里不能夠直接對原來的二維數(shù)組進行排序,因為會丟失每一個區(qū)間的原始下標位置。代碼中采用了內(nèi)部類Node來記錄每一個區(qū)間的左邊界以及每一個區(qū)間的原始下標,并對Node進行排序和二分法查找。代碼如下:

    public int[] findRightInterval(int[][] intervals) {        
        int[] result = new int[intervals.length];
        Arrays.fill(result, -1);
        
        Node[] leftIndex = new Node[intervals.length];
        for(int i = 0 ; i rightIndex) {
                    right = mid - 1;
                }else {
                    left = mid + 1;
                }
            }
            if(leftIndex[right].value == rightIndex) {
                result[i] = leftIndex[right].index;
            }else if(right{
        int value;
        int index;
        @Override
        public int compareTo(Node o) {
            // TODO Auto-generated method stub
            return this.value - o.value;
        }
    }
思路二:桶排序

換一種思路,有沒有辦法將所有的區(qū)間用一維數(shù)組的方式展開,一維數(shù)組的每一個下標上的值,都記錄了該位置所在的右側(cè)第一個區(qū)間。具體流程如下:

假設(shè)輸入為[3,4], [2,3], [1,2]的三個區(qū)間,展開來后我們知道這里的三個區(qū)間橫跨了[1,4]這么一個區(qū)間

我們可以用長度為4的一維數(shù)組bucket來表示這個完整的區(qū)間,其中每一個下標代表的位置都以左邊界作為偏移值,如數(shù)組的0下標其實代表位置1,數(shù)組的1下標代表位置2。

先根據(jù)所有區(qū)間的左值更新區(qū)間數(shù)組,如[3,4]代表著區(qū)間數(shù)組中位置為3-1=2的位置的第一個右側(cè)區(qū)間為[3,4], 因此bucket[2]=0, 同理bucket[1]=0, bucket[0]=1

開始查詢時,如果當前桶下標上沒有記錄右側(cè)的第一個區(qū)間,則不停的向右遍歷,直到找到第一個值。如果沒找到,則說明其右側(cè)不存在區(qū)間了。反過來,也可以從右往左遍歷bucket數(shù)組,每遇到一個沒有填充的位置,就將右側(cè)的值賦予當前位置。

代碼如下:

    public int[] findRightInterval(int[][] intervals) {
        int[] result = new int[intervals.length];
        int min = intervals[0][0], max = intervals[0][1];
        
        for(int i = 1 ; i=0 ; i--) {
            if(buckets[i] == -1) buckets[i] = buckets[i+1]; 
        }
        
        for(int i = 0 ; i

這里的核心思路在于,如何理解bucket數(shù)組,這個bucket數(shù)組本質(zhì)上是將所有的區(qū)間以最左邊界和最右邊界展開,數(shù)組的每一個下標對應(yīng)著區(qū)間中的相對位置,并記錄了這個下標右側(cè)的第一個區(qū)間的位置。

文章版權(quán)歸作者所有,未經(jīng)允許請勿轉(zhuǎn)載,若此文章存在違規(guī)行為,您可以聯(lián)系管理員刪除。

轉(zhuǎn)載請注明本文地址:http://specialneedsforspecialkids.com/yun/75332.html

相關(guān)文章

  • [LeetCode] 689. Maximum Sum of 3 Non-Overlapping S

    摘要: Problem In a given array nums of positive integers, find three non-overlapping subarrays with maximum sum. Each subarray will be of size k, and we want to maximize the sum of all 3*k entries. R...

    dailybird 評論0 收藏0
  • SVG做圓環(huán)進度

    摘要:哈哈動態(tài)效果是用來實現(xiàn)的,,至于進度則是用控制屬性實現(xiàn)的。。代碼如下首先看下結(jié)構(gòu)加油開始濾鏡效果對于不熟悉的,先看下基本教程接下來看下樣式最后就腳本了,代碼不多,也很簡單,就是設(shè)置屬性圓環(huán)進度條謝謝關(guān)注 我們要實現(xiàn)的效果:showImg(https://segmentfault.com/img/bVJyQ0?w=440&h=392); 是不是有點感覺。。。哈哈 動態(tài)效果是用css3來實...

    Elle 評論0 收藏0
  • [Leetcode] Meeting Rooms 會議室

    摘要:排序法復(fù)雜度時間空間思路這題和很像,我們按開始時間把這些都給排序后,就挨個檢查是否有沖突就行了。有沖突的定義是開始時間小于之前最晚的結(jié)束時間。這里之前最晚的結(jié)束時間不一定是上一個的結(jié)束時間,所以我們更新的時候要取最大值。 Meeting Rooms Given an array of meeting time intervals consisting of start and end...

    jubincn 評論0 收藏0
  • [LeetCode] 253. Meeting Rooms II

    Problem Given an array of meeting time intervals consisting of start and end times [[s1,e1],[s2,e2],...] (si < ei), find the minimum number of conference rooms required. Example 1: Input: [[0, 30],[5,...

    mengera88 評論0 收藏0
  • [LeetCode] 435. Non-overlapping Intervals

    Problem Given a collection of intervals, find the minimum number of intervals you need to remove to make the rest of the intervals non-overlapping. Note:You may assume the intervals end point is alway...

    mrcode 評論0 收藏0

發(fā)表評論

0條評論

閱讀需要支付1元查看
<